.386
.model flat, stdcall
option casemap :none   ; case sensitive

include WBDll.inc
include WBCtl.asm

.code

;Create a windowclass for the user control
CreateClass proc hInst:HINSTANCE
	LOCAL	wc:WNDCLASSEX

	invoke RtlZeroMemory,addr wc,sizeof wc
	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS
	mov		wc.lpfnWndProc,offset WBProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,4		;Holds memory handle
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,NULL;COLOR_BTNFACE+1
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset szClassNameWB
	mov		eax,NULL
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	ret

CreateClass endp

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD

	mov		eax,reason
	.if eax==DLL_PROCESS_ATTACH
		invoke CreateClass,hInst
		push	hInst
		pop		hInstance
		; Initialize the COM Library
		invoke CoInitialize,NULL
	.elseif eax==DLL_PROCESS_DETACH
		; Uninitialize the COM Library
		invoke CoUninitialize
	.endif
	mov		eax,TRUE
	ret

DllEntry Endp

;NOTE: RadASM 1.2.0.5 uses this method.
;In RadASM.ini section [CustCtrl], x=CustCtrl.dll,y
;x is next free number.
;y is number of controls in the dll. In this case there is only one control.
;
;x=WBDll.dll,1
;Copy WBDll.dll to c:\windows\system
;
GetDef proc nInx:DWORD

	mov		eax,nInx
	.if !eax
		;Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_WBBUTTON
		mov		ccdef.hbmp,eax
		;Return pointer to inited struct
		mov		eax,offset ccdef
	.else
		xor		eax,eax
	.endif
	ret

GetDef endp

GetDefEx proc nInx:DWORD

	mov		eax,nInx
	.if !eax
		;Get the toolbox bitmap
		invoke LoadBitmap,hInstance,IDB_WBBUTTON
		mov		ccdefex.hbmp,eax
		;Return pointer to inited struct
		mov		eax,offset ccdefex
	.else
		xor		eax,eax
	.endif
	ret

GetDefEx endp

;--------------------------------------------------------------------------------

;Maintain the adressbar combo
FindCbo proc hWin:DWORD
	LOCAL	txtLen:DWORD

	invoke GetWindowTextLength,hWin
	inc		eax ; space for NULL
	mov		txtLen,eax
	.if eax>1 ; some text entered
		invoke GetWindowText,hWin,offset buffer,sizeof buffer
		; find 
		invoke SendMessage,hWin,CB_FINDSTRINGEXACT,-1,offset buffer
		.if eax!=-1 ; if item found
			invoke SendMessage,hWin,CB_DELETESTRING,eax,eax
		.endif
		; insert string
		invoke SendMessage,hWin,CB_INSERTSTRING,0,offset buffer
		; set list selection
		invoke SendMessage,hWin,CB_SETCURSEL,0,0
		; select text in combobox
		invoke SendMessage,hWin,CB_SETEDITSEL,0,txtLen
	.endif				  
	ret

FindCbo endp

;Goto a website
WebBrowserNavigate proc uses ebx,hWin:HWND,lpSite:DWORD
	LOCAL	bstrURL[MAX_PATH*2]:word

	invoke GetWindowLong,hWin,0
	mov		ebx,eax
	; Convert the path to BSTR
	invoke MultiByteToWideChar,CP_ACP,0,lpSite,-1,addr bstrURL,MAX_PATH*2
	.IF !eax
		jmp		@fail
	.ENDIF
	; Navigate to a "Web Page"
	mov		ecx,[ebx].WBDATA.pObj
	coinvoke [ecx].Object._pWebBrowserOC,IWebBrowser,Navigate,addr bstrURL,NULL,NULL,NULL,NULL
   .IF_FAILED
		jmp		@fail
	.endif
	.if [ebx].WBDATA.hWBComboWnd
		invoke SetWindowText,[ebx].WBDATA.hWBComboWnd,lpSite
		invoke FindCbo,[ebx].WBDATA.hWBComboWnd
	.endif
	; Exit successfully
	mov		eax, S_OK
	jmp		@ex
  @fail:
	mov eax, E_FAIL
  @ex:
	ret

WebBrowserNavigate endp

WebBrowserGoBack proc uses ebx,hWin:HWND

	invoke GetWindowLong,hWin,0
	mov		ebx,eax
	mov		ecx,[ebx].WBDATA.pObj
	coinvoke [ecx].Object._pWebBrowserOC,IWebBrowser,GoBack
	ret

WebBrowserGoBack endp

WebBrowserGoForward proc uses ebx,hWin:HWND

	invoke GetWindowLong,hWin,0
	mov		ebx,eax
	mov		ecx,[ebx].WBDATA.pObj
	coinvoke [ecx].Object._pWebBrowserOC,IWebBrowser,GoForward
	ret

WebBrowserGoForward endp

;Subclassed combobox edit control
EditProc proc uses ebx,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	.if uMsg==WM_KEYDOWN
		.if wParam==VK_RETURN
			invoke GetWindowLong,hWin,GWL_ID
			mov		ebx,eax
			invoke FindCbo,[ebx].WBDATA.hWBComboWnd
			mov		eax,CBN_SELCHANGE
			shl		eax,16
			invoke PostMessage,[ebx].WBDATA.hWBParentWnd,WM_COMMAND,eax,0
			xor		eax,eax
			ret
		.endif
	.endif
	invoke CallWindowProc,lpfnEditProc,hWin,uMsg,wParam,lParam
	ret

EditProc endp

;Create adress and statusbar if style is selected
CreateWBControls proc uses ebx,hWin:HWND,fStyle:DWORD

	invoke GetWindowLong,hWin,0
	mov		ebx,eax
	mov		eax,fStyle
	mov		edx,eax
	and		eax,WBS_STATUSWINDOW
	.if eax
		mov		eax,WS_CHILD or WS_VISIBLE
		test	edx,WBS_STATUSSIZEGRIP
		.if !ZERO?
			or		eax,SBARS_SIZEGRIP
		.endif
		invoke CreateWindowEx,NULL,offset szClassStatus,NULL,eax,0,0,0,0,hWin,0,hInstance,0
	.endif
	mov		[ebx].WBDATA.hWBStatusWnd,eax
	mov		eax,fStyle
	and		eax,WBS_CAPTION
	.if eax
		invoke GetWindowText,hWin,offset buffer,sizeof buffer
		invoke CreateWindowEx,NULL,offset szClassStatic,offset buffer,WS_CHILD or WS_VISIBLE,0,0,0,0,hWin,0,hInstance,0
	.endif
	mov		[ebx].WBDATA.hWBCaptionWnd,eax
	mov		eax,fStyle
	and		eax,WBS_COMBO
	.if eax
		invoke CreateWindowEx,NULL,offset szClassCombo,NULL,WS_CHILD or WS_VISIBLE or CBS_DROPDOWN,0,0,300,100,hWin,0,hInstance,0
		push	eax
		invoke GetWindow,eax,GW_CHILD
		push	eax
		invoke SetWindowLong,eax,GWL_WNDPROC,offset EditProc
		mov		lpfnEditProc,eax
		pop		eax
		invoke SetWindowLong,eax,GWL_ID,ebx
		pop		eax
	.endif
	mov		[ebx].WBDATA.hWBComboWnd,eax
	ret

CreateWBControls endp

;The WB callback (WndProc).
WBProc proc uses ebx,hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	LOCAL	rect:RECT

	mov		eax,uMsg
	.if eax==WM_CREATE
		invoke GetProcessHeap
		invoke HeapAlloc,eax,HEAP_ZERO_MEMORY,sizeof WBDATA
		mov		ebx,eax
		invoke SetWindowLong,hWin,0,ebx
		mov		eax,hWin
		mov		[ebx].WBDATA.hWBParentWnd,eax
		invoke GetWindowLong,hWin,GWL_STYLE
		invoke CreateWBControls,hWin,eax
		invoke CreateWebBrowser,hWin
	.elseif eax==WM_SIZE
		invoke ResizeWebBrowser,hWin
	.elseif eax==WM_SETFONT
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		.if [ebx].WBDATA.hWBStatusWnd
			invoke SendMessage,[ebx].WBDATA.hWBStatusWnd,WM_SETFONT,wParam,lParam
		.endif
		.if [ebx].WBDATA.hWBComboWnd
			invoke SendMessage,[ebx].WBDATA.hWBComboWnd,WM_SETFONT,wParam,lParam
		.endif
		invoke ResizeWebBrowser,hWin
		.if [ebx].WBDATA.hWBCaptionWnd
			invoke SendMessage,[ebx].WBDATA.hWBCaptionWnd,WM_SETFONT,wParam,lParam
		.endif
	.elseif eax==WM_DESTROY
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		invoke CleanupWebBrowser,[ebx].WBDATA.pObj
		invoke DestroyWindow,[ebx].WBDATA.hWBStatusWnd
		invoke DestroyWindow,[ebx].WBDATA.hWBCaptionWnd
		invoke DestroyWindow,[ebx].WBDATA.hWBComboWnd
		invoke GetProcessHeap
		invoke HeapFree,eax,NULL,ebx
	.elseif eax==WM_COMMAND
		invoke GetWindowLong,hWin,0
		mov		ebx,eax
		mov		eax,wParam
		mov		edx,eax
		shr		edx,16
		and		eax,0FFFFh
		.if edx==CBN_SELCHANGE
			invoke SendMessage,[ebx].WBDATA.hWBComboWnd,CB_GETCURSEL,0,0
			mov		edx,eax
			invoke SendMessage,[ebx].WBDATA.hWBComboWnd,CB_GETLBTEXT,edx,offset buffer
			invoke WebBrowserNavigate,hWin,offset buffer
			xor		eax,eax
			jmp		@ex
		.endif
	.elseif eax==WBM_RAINIT
		;WM_USER+9999 (=WBM_RAINIT) is sendt to a custom control by RadASM (1.2.0.5)
		;to let the custom control fill in default design time values.
		;
		invoke WebBrowserNavigate,hWin,offset szNULL
		xor		eax,eax
		jmp		@ex
	.elseif eax==WBM_NAVIGATE
		invoke WebBrowserNavigate,hWin,lParam
		xor		eax,eax
		jmp		@ex
	.elseif eax==WBM_GOBACK
		invoke WebBrowserGoBack,hWin
		xor		eax,eax
		jmp		@ex
	.elseif eax==WBM_GOFORWARD
		invoke WebBrowserGoForward,hWin
		xor		eax,eax
		jmp		@ex
	.endif
	invoke DefWindowProc,hWin,uMsg,wParam,lParam
  @ex:
	ret

WBProc endp

End DllEntry
